#include <avr/io.h>
#include <avr/interrupt.h>

#define F_CPU 4915200UL
#include <util/delay.h> 

#define BAUD        38400UL
#define UBRR_BAUD   ((F_CPU/(16UL*BAUD))-1)

volatile uint8_t counter = 0;
volatile uint8_t rx[4];


ISR(USART_RX_vect) //wenn ber RS232 Was kommt...
{
	rx[counter] = UDR; //Daten zwischenspeichern
	counter++;
	if(counter > 3){  //und in R / G / B aufteilen
	    OCR0A =  rx[1];  //red
	    OCR1AL = rx[2];//green
	    OCR1BL = rx[3]; //blue
		counter = 0;
	}
}

void uart_init(void)  //Uart Starten
{
    UBRRH = (unsigned char) (UBRR_BAUD>>8);
    UBRRL = (unsigned char) (UBRR_BAUD & 0x0ff);

    UCSRB = (1<<RXCIE)|(1<<RXEN);

    UCSRC = (1 << UCSZ0) | (1 << UCSZ1);
}


int main(void)
{
    DDRB = (1 << PB4 ) | (1 << PB3 ) | (1 << PB2 );  //PWM Einrichten anfang

	
    TCCR0A = (1<<COM1A1)|(1<<COM1B1)|(1<<WGM10);
	TCCR0B = (1<<CS10);

    TCCR1A = (1<<COM1A1)|(1<<COM1B1)|(1<<WGM10);
    TCCR1B = (1<<CS10);
    TIMSK &= ~0x3c;  //PWM Einrichten Ende

	OCR0A = 200;  //red
    OCR1AL = 0xff;//green
    OCR1BL = 127; //blue

	uart_init();

    sei();

  while( 1 )  //warten... auf Befehle
    ;  
}
